// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Navigator;
use glib::{prelude::*, translate::*};
use std::fmt;

glib::wrapper! {
    #[doc(alias = "GspellNavigatorTextView")]
    pub struct NavigatorTextView(Object<ffi::GspellNavigatorTextView, ffi::GspellNavigatorTextViewClass>) @implements Navigator;

    match fn {
        type_ => || ffi::gspell_navigator_text_view_get_type(),
    }
}

impl NavigatorTextView {
    pub const NONE: Option<&'static NavigatorTextView> = None;

    // rustdoc-stripper-ignore-next
    /// Creates a new builder-pattern struct instance to construct [`NavigatorTextView`] objects.
    ///
    /// This method returns an instance of [`NavigatorTextViewBuilder`](crate::builders::NavigatorTextViewBuilder) which can be used to create [`NavigatorTextView`] objects.
    pub fn builder() -> NavigatorTextViewBuilder {
        NavigatorTextViewBuilder::new()
    }

    #[doc(alias = "gspell_navigator_text_view_new")]
    pub fn new(view: &impl IsA<gtk::TextView>) -> Option<Navigator> {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_none(ffi::gspell_navigator_text_view_new(
                view.as_ref().to_glib_none().0,
            ))
        }
    }
}

// rustdoc-stripper-ignore-next
/// A [builder-pattern] type to construct [`NavigatorTextView`] objects.
///
/// [builder-pattern]: https://doc.rust-lang.org/1.0.0/style/ownership/builders.html
#[must_use = "The builder must be built to be used"]
pub struct NavigatorTextViewBuilder {
    builder: glib::object::ObjectBuilder<'static, NavigatorTextView>,
}

impl NavigatorTextViewBuilder {
    fn new() -> Self {
        Self {
            builder: glib::object::Object::builder(),
        }
    }

    pub fn view(self, view: &impl IsA<gtk::TextView>) -> Self {
        Self {
            builder: self.builder.property("view", view.clone().upcast()),
        }
    }

    // rustdoc-stripper-ignore-next
    /// Build the [`NavigatorTextView`].
    #[must_use = "Building the object from the builder is usually expensive and is not expected to have side effects"]
    pub fn build(self) -> NavigatorTextView {
        self.builder.build()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::NavigatorTextView>> Sealed for T {}
}

pub trait NavigatorTextViewExt: IsA<NavigatorTextView> + sealed::Sealed + 'static {
    #[doc(alias = "gspell_navigator_text_view_get_view")]
    #[doc(alias = "get_view")]
    fn view(&self) -> Option<gtk::TextView> {
        unsafe {
            from_glib_none(ffi::gspell_navigator_text_view_get_view(
                self.as_ref().to_glib_none().0,
            ))
        }
    }
}

impl<O: IsA<NavigatorTextView>> NavigatorTextViewExt for O {}

impl fmt::Display for NavigatorTextView {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("NavigatorTextView")
    }
}
